import java.io.*;
import java.util.*;

class PorterDriver
{

   public static void main(String[] args) 
   {
      for (int i = 0; i < args.length; i++)
      try
      {
         BufferedReader in = new BufferedReader(
				  new InputStreamReader(
				  new FileInputStream(args[i])));
         try
         { 
	     while(true)
	     {  
		 String line;
		 String word;
		 String stem;
		 
		 line = in.readLine();
		 if (line == null)
		     break;
		 StringTokenizer tokens = 
		     new StringTokenizer(line, " .,+-*/;!\n");

		 while (tokens.hasMoreTokens())
		 {
		     word = tokens.nextToken();
		     stem = Porter.canonicalize(word);
		     System.out.println("word : " + word + " stem: " + stem);
		 }

	     }
	 }
	 catch (IOException e)
         {  
	     System.out.println("error reading " + args[i]);
	     break;
         }
      }
      catch (FileNotFoundException e)
      {  
	  System.out.println("file " + args[i] + " not found");
	  break;
      }
   }
}
